/* archiveReader.c generated by valac 0.42.6, the Vala compiler
 * generated from archiveReader.vala, do not modify */

/*///////////////////////////////////////////////////////////////////////*/
/* Copyright (c) 2011-2017 by Simon Schneegans*/
/**/
/* This program is free software: you can redistribute it and/or modify*/
/* it under the terms of the GNU General Public License as published by*/
/* the Free Software Foundation, either version 3 of the License, or (at*/
/* your option) any later version.*/
/**/
/* This program is distributed in the hope that it will be useful, but*/
/* WITHOUT ANY WARRANTY; without even the implied warranty of*/
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU*/
/* General Public License for more details.*/
/**/
/* You should have received a copy of the GNU General Public License*/
/* along with this program.  If not, see <http://www.gnu.org/licenses/>.*/
/*///////////////////////////////////////////////////////////////////////*/


#include <glib.h>
#include <glib-object.h>
#include <archive.h>
#include <stdlib.h>
#include <string.h>
#include <archive_entry.h>


#define GNOME_PIE_TYPE_ARCHIVE_READER (gnome_pie_archive_reader_get_type ())
#define GNOME_PIE_ARCHIVE_READER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GNOME_PIE_TYPE_ARCHIVE_READER, GnomePieArchiveReader))
#define GNOME_PIE_ARCHIVE_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GNOME_PIE_TYPE_ARCHIVE_READER, GnomePieArchiveReaderClass))
#define GNOME_PIE_IS_ARCHIVE_READER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GNOME_PIE_TYPE_ARCHIVE_READER))
#define GNOME_PIE_IS_ARCHIVE_READER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GNOME_PIE_TYPE_ARCHIVE_READER))
#define GNOME_PIE_ARCHIVE_READER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GNOME_PIE_TYPE_ARCHIVE_READER, GnomePieArchiveReaderClass))

typedef struct _GnomePieArchiveReader GnomePieArchiveReader;
typedef struct _GnomePieArchiveReaderClass GnomePieArchiveReaderClass;
typedef struct _GnomePieArchiveReaderPrivate GnomePieArchiveReaderPrivate;
enum  {
	GNOME_PIE_ARCHIVE_READER_0_PROPERTY,
	GNOME_PIE_ARCHIVE_READER_NUM_PROPERTIES
};
static GParamSpec* gnome_pie_archive_reader_properties[GNOME_PIE_ARCHIVE_READER_NUM_PROPERTIES];
#define _archive_read_free0(var) ((var == NULL) ? NULL : (var = (archive_read_free (var), NULL)))
#define _archive_write_free0(var) ((var == NULL) ? NULL : (var = (archive_write_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

struct _GnomePieArchiveReader {
	GObject parent_instance;
	GnomePieArchiveReaderPrivate * priv;
};

struct _GnomePieArchiveReaderClass {
	GObjectClass parent_class;
};

struct _GnomePieArchiveReaderPrivate {
	struct archive* archive;
	struct archive* writer;
};


static gint GnomePieArchiveReader_private_offset;
static gpointer gnome_pie_archive_reader_parent_class = NULL;

GType gnome_pie_archive_reader_get_type (void) G_GNUC_CONST;
GnomePieArchiveReader* gnome_pie_archive_reader_new (void);
GnomePieArchiveReader* gnome_pie_archive_reader_construct (GType object_type);
gboolean gnome_pie_archive_reader_open (GnomePieArchiveReader* self,
                                        const gchar* path);
gboolean gnome_pie_archive_reader_extract_to (GnomePieArchiveReader* self,
                                              const gchar* directory);
static guint8* _vala_array_dup2 (guint8* self,
                          int length);
void gnome_pie_archive_reader_close (GnomePieArchiveReader* self);
static void gnome_pie_archive_reader_finalize (GObject * obj);


static inline gpointer
gnome_pie_archive_reader_get_instance_private (GnomePieArchiveReader* self)
{
	return G_STRUCT_MEMBER_P (self, GnomePieArchiveReader_private_offset);
}


GnomePieArchiveReader*
gnome_pie_archive_reader_construct (GType object_type)
{
	GnomePieArchiveReader * self = NULL;
	struct archive* _tmp0_;
	struct archive* _tmp1_;
	struct archive* _tmp2_;
	struct archive* _tmp3_;
	struct archive* _tmp4_;
	struct archive* _tmp5_;
	self = (GnomePieArchiveReader*) g_object_new (object_type, NULL);
	_tmp0_ = archive_read_new ();
	_archive_read_free0 (self->priv->archive);
	self->priv->archive = _tmp0_;
	_tmp1_ = self->priv->archive;
	archive_read_support_format_all (_tmp1_);
	_tmp2_ = self->priv->archive;
	archive_read_support_filter_all (_tmp2_);
	_tmp3_ = archive_write_disk_new ();
	_archive_write_free0 (self->priv->writer);
	self->priv->writer = _tmp3_;
	_tmp4_ = self->priv->writer;
	archive_write_disk_set_options (_tmp4_, ((ARCHIVE_EXTRACT_TIME | ARCHIVE_EXTRACT_PERM) | ARCHIVE_EXTRACT_ACL) | ARCHIVE_EXTRACT_FFLAGS);
	_tmp5_ = self->priv->writer;
	archive_write_disk_set_standard_lookup (_tmp5_);
	return self;
}


GnomePieArchiveReader*
gnome_pie_archive_reader_new (void)
{
	return gnome_pie_archive_reader_construct (GNOME_PIE_TYPE_ARCHIVE_READER);
}


gboolean
gnome_pie_archive_reader_open (GnomePieArchiveReader* self,
                               const gchar* path)
{
	gboolean result = FALSE;
	struct archive* _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (path != NULL, FALSE);
	_tmp0_ = self->priv->archive;
	result = archive_read_open_filename (_tmp0_, path, (gsize) 10240) == ARCHIVE_OK;
	return result;
}


static guint8*
_vala_array_dup2 (guint8* self,
                  int length)
{
	return g_memdup (self, length * sizeof (guint8));
}


gboolean
gnome_pie_archive_reader_extract_to (GnomePieArchiveReader* self,
                                     const gchar* directory)
{
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (directory != NULL, FALSE);
	while (TRUE) {
		struct archive_entry* entry = NULL;
		int r = 0;
		struct archive* _tmp0_;
		struct archive_entry* _tmp1_ = NULL;
		int _tmp2_;
		int _tmp3_;
		int _tmp4_;
		struct archive_entry* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		struct archive_entry* _tmp10_;
		const gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		struct archive* _tmp14_;
		struct archive_entry* _tmp15_;
		int _tmp16_;
		struct archive_entry* _tmp19_;
		struct archive* _tmp33_;
		int _tmp34_;
		_tmp0_ = self->priv->archive;
		_tmp2_ = archive_read_next_header (_tmp0_, &_tmp1_);
		entry = _tmp1_;
		r = _tmp2_;
		_tmp3_ = r;
		if (_tmp3_ == ARCHIVE_EOF) {
			break;
		}
		_tmp4_ = r;
		if (_tmp4_ != ARCHIVE_OK) {
			struct archive* _tmp5_;
			const gchar* _tmp6_;
			_tmp5_ = self->priv->archive;
			_tmp6_ = archive_error_string (_tmp5_);
			g_warning ("archiveReader.vala:71: %s", _tmp6_);
			result = FALSE;
			return result;
		}
		_tmp7_ = entry;
		_tmp8_ = g_strconcat (directory, "/", NULL);
		_tmp9_ = _tmp8_;
		_tmp10_ = entry;
		_tmp11_ = archive_entry_pathname (_tmp10_);
		_tmp12_ = g_strconcat (_tmp9_, _tmp11_, NULL);
		_tmp13_ = _tmp12_;
		archive_entry_set_pathname (_tmp7_, _tmp13_);
		_g_free0 (_tmp13_);
		_g_free0 (_tmp9_);
		_tmp14_ = self->priv->writer;
		_tmp15_ = entry;
		r = archive_write_header (_tmp14_, _tmp15_);
		_tmp16_ = r;
		if (_tmp16_ != ARCHIVE_OK) {
			struct archive* _tmp17_;
			const gchar* _tmp18_;
			_tmp17_ = self->priv->writer;
			_tmp18_ = archive_error_string (_tmp17_);
			g_warning ("archiveReader.vala:80: %s", _tmp18_);
			result = FALSE;
			return result;
		}
		_tmp19_ = entry;
		if (archive_entry_size (_tmp19_) > ((la_int64_t) 0)) {
			while (TRUE) {
				gsize offset = 0UL;
				gsize size = 0UL;
				guint8* buff = NULL;
				gint buff_length1 = 0;
				gint _buff_size_ = 0;
				struct archive* _tmp20_;
				guint8* _tmp21_ = NULL;
				size_t _tmp22_;
				la_int64_t _tmp23_ = {0};
				int _tmp24_;
				guint8* _tmp25_;
				gint _tmp25__length1;
				int _tmp26_;
				int _tmp27_;
				struct archive* _tmp30_;
				guint8* _tmp31_;
				gint _tmp31__length1;
				gsize _tmp32_;
				_tmp20_ = self->priv->archive;
				_tmp24_ = archive_read_data_block (_tmp20_, &_tmp21_, &_tmp22_, &_tmp23_);
				buff = (g_free (buff), NULL);
				_tmp25_ = (_tmp21_ != NULL) ? _vala_array_dup2 (_tmp21_, _tmp22_) : ((gpointer) _tmp21_);
				_tmp25__length1 = _tmp22_;
				buff = _tmp25_;
				buff_length1 = _tmp25__length1;
				_buff_size_ = buff_length1;
				offset = (gsize) _tmp23_;
				r = _tmp24_;
				_tmp26_ = r;
				if (_tmp26_ == ARCHIVE_EOF) {
					buff = (g_free (buff), NULL);
					break;
				}
				_tmp27_ = r;
				if (_tmp27_ != ARCHIVE_OK) {
					struct archive* _tmp28_;
					const gchar* _tmp29_;
					_tmp28_ = self->priv->archive;
					_tmp29_ = archive_error_string (_tmp28_);
					g_warning ("archiveReader.vala:99: %s", _tmp29_);
					result = FALSE;
					buff = (g_free (buff), NULL);
					return result;
				}
				_tmp30_ = self->priv->writer;
				_tmp31_ = buff;
				_tmp31__length1 = buff_length1;
				_tmp32_ = offset;
				archive_write_data_block (_tmp30_, _tmp31_, (size_t) _tmp31__length1, (la_int64_t) _tmp32_);
				buff = (g_free (buff), NULL);
			}
		}
		_tmp33_ = self->priv->writer;
		r = archive_write_finish_entry (_tmp33_);
		_tmp34_ = r;
		if (_tmp34_ != ARCHIVE_OK) {
			struct archive* _tmp35_;
			const gchar* _tmp36_;
			_tmp35_ = self->priv->writer;
			_tmp36_ = archive_error_string (_tmp35_);
			g_warning ("archiveReader.vala:114: %s", _tmp36_);
			result = FALSE;
			return result;
		}
	}
	result = TRUE;
	return result;
}


void
gnome_pie_archive_reader_close (GnomePieArchiveReader* self)
{
	struct archive* _tmp0_;
	struct archive* _tmp1_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->archive;
	archive_read_close (_tmp0_);
	_tmp1_ = self->priv->writer;
	archive_write_close (_tmp1_);
}


static void
gnome_pie_archive_reader_class_init (GnomePieArchiveReaderClass * klass)
{
	gnome_pie_archive_reader_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &GnomePieArchiveReader_private_offset);
	G_OBJECT_CLASS (klass)->finalize = gnome_pie_archive_reader_finalize;
}


static void
gnome_pie_archive_reader_instance_init (GnomePieArchiveReader * self)
{
	self->priv = gnome_pie_archive_reader_get_instance_private (self);
}


static void
gnome_pie_archive_reader_finalize (GObject * obj)
{
	GnomePieArchiveReader * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GNOME_PIE_TYPE_ARCHIVE_READER, GnomePieArchiveReader);
	_archive_read_free0 (self->priv->archive);
	_archive_write_free0 (self->priv->writer);
	G_OBJECT_CLASS (gnome_pie_archive_reader_parent_class)->finalize (obj);
}


GType
gnome_pie_archive_reader_get_type (void)
{
	static volatile gsize gnome_pie_archive_reader_type_id__volatile = 0;
	if (g_once_init_enter (&gnome_pie_archive_reader_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GnomePieArchiveReaderClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gnome_pie_archive_reader_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GnomePieArchiveReader), 0, (GInstanceInitFunc) gnome_pie_archive_reader_instance_init, NULL };
		GType gnome_pie_archive_reader_type_id;
		gnome_pie_archive_reader_type_id = g_type_register_static (G_TYPE_OBJECT, "GnomePieArchiveReader", &g_define_type_info, 0);
		GnomePieArchiveReader_private_offset = g_type_add_instance_private (gnome_pie_archive_reader_type_id, sizeof (GnomePieArchiveReaderPrivate));
		g_once_init_leave (&gnome_pie_archive_reader_type_id__volatile, gnome_pie_archive_reader_type_id);
	}
	return gnome_pie_archive_reader_type_id__volatile;
}



